package org.msrb.emma.subscriber;

import java.io.Closeable;
import java.io.IOException;
import java.util.Date;
import java.util.GregorianCalendar;
import javax.xml.datatype.DatatypeConfigurationException;
import javax.xml.datatype.DatatypeFactory;
import javax.xml.datatype.XMLGregorianCalendar;
import java.util.TimeZone;

/**
 *
 * @author admin
 */
public abstract class EmmaSoapSubscriberClient implements EmmaSubscriberClient {

    protected IEmmaSubscriptionService port;

    protected abstract IEmmaSubscriptionService getPort();

    private static XMLGregorianCalendar getSoapDateTime(Date requestDate) throws DatatypeConfigurationException {
        TimeZone zone = TimeZone.getTimeZone("America/New_York");        
        final GregorianCalendar c = new GregorianCalendar();
        c.setTimeZone(zone);
        c.setTime(requestDate);
        return DatatypeFactory.newInstance().newXMLGregorianCalendar(c);
    }

    @Override
    public byte[] getFile(String fileId) throws IEmmaSubscriptionServiceGetFileFileRetrievalFaultFaultFaultMessage {
        return getPort().getFile(fileId);
    }

    @Override
    public SingleEmmaTransaction getTransaction(String submissionType, Date postingDateTime, String submissionId, String specVersion) throws DatatypeConfigurationException {
        return getPort().getTransaction(submissionType, getSoapDateTime(postingDateTime), submissionId, specVersion);
    }

    @Override
    public EmmaTransactionList getTransactions(String submissionType, Date postingDate, String specVersion) throws DatatypeConfigurationException {
        return getPort().getTransactions(submissionType, getSoapDateTime(postingDate), specVersion);
    }

    public void close() throws IOException {
        ((Closeable) port).close();
    }

}
