package org.msrb.emma.subscriber;

import com.sun.xml.wss.XWSSConstants;
import java.net.URL;

public class EmmaSubscriberPasswordClient extends EmmaSoapSubscriberClient {

    private final String userName;
    private final String password;
    private final URL url;

    public EmmaSubscriberPasswordClient(URL url, String userName, String password) {
        this.userName = userName;
        this.password = password;
        this.url = url;
    }

    @Override
    protected IEmmaSubscriptionService getPort() {
        if (port == null) {
            org.msrb.emma.subscriber.EmmaSubscriptionService service = new org.msrb.emma.subscriber.EmmaSubscriptionService(url);
            port = service.getSubscriber();
            ((javax.xml.ws.BindingProvider) port).getRequestContext().put(XWSSConstants.USERNAME_PROPERTY, userName);
            ((javax.xml.ws.BindingProvider) port).getRequestContext().put(XWSSConstants.PASSWORD_PROPERTY, password);
        }
        return port;
    }

}
